﻿using AutoMapper;
using IdentityServer3.Core.Services;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.Options;
using MySql.Data.MySqlClient;
using ServiceStack.Configuration;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using YouthBooking.Models;

// For more information on enabling Web API for empty projects, visit https://go.microsoft.com/fwlink/?LinkID=397860

namespace YouthBooking.Controllers
{
    [Route("api/[controller]")]
    [ApiController]
    public class CustomerController : ControllerBase
    {
        private readonly IConfiguration Configuration;
        private string _connectionString;

        public CustomerController(IConfiguration configuration)
        {
            Configuration = configuration;
            var server = Configuration["MySQLConnection:Server"];
            var userid = Configuration["MySQLConnection:UserId"];
            var password = Configuration["MySQLConnection:Password"];
            var databasename = Configuration["MySQLConnection:Database"];
            _connectionString = $"server={server};userid={userid};password={password};database={databasename}";
        }


        // Get api/<CustomerController>/login
        [Route("login")]
        [HttpGet()]
        public ActionResult<object> LoginCustomer(string username, string password)
        {
            var con = new MySqlConnection(_connectionString);
            con.Open();

            string sql = $"SELECT * FROM customer where username='{username}' AND password='{password}'";
            var cmd = new MySqlCommand(sql, con);

            MySqlDataReader rdr = cmd.ExecuteReader();

            if (rdr.Read())
            {
                CustomerDto customer = new() { Id = rdr.GetUInt32(0), Username = rdr.GetString(1), Firstname = rdr.GetString(2), Lastname = rdr.GetString(3), Email = rdr.GetString(4), UserRights = rdr.GetUInt32(5), AdminRights = rdr.GetUInt32(6) };
                return Ok(customer);
            }
            else
            {
                return NotFound(new { ErrorCode = 404, ErrorMessage = "Invalid login. Unknown username or password." });
            }
        }

        // GET api/<CustomerController>/retrieve
        [Route("retrieve")]
        [HttpGet()]
        public ActionResult<object> RetrieveCustomer(string username)
        {
            var con = new MySqlConnection(_connectionString);
            con.Open();

            string sql = $"SELECT * FROM customer where username='{username}'";
            var cmd = new MySqlCommand(sql, con);

            MySqlDataReader rdr = cmd.ExecuteReader();

            if (rdr.Read())
            {
                CustomerDto customer = new() { Id = rdr.GetUInt32(0), Username = rdr.GetString(1), Firstname = rdr.GetString(2), Lastname = rdr.GetString(3), Email = rdr.GetString(4), UserRights = rdr.GetUInt32(5), AdminRights = rdr.GetUInt32(6) };
                return Ok(customer);
            }
            else
            {
                return NotFound(new { ErrorCode = 404, ErrorMessage = "Customer not found" });
            }
        }

        // POST api/<CustomerController>
        [Route("new")]
        [HttpPost]
        public ActionResult<object> NewCustomer([FromBody] CustomerDto customer)
        {
            var con = new MySqlConnection(_connectionString);
            con.Open();

            string sql = $"INSERT INTO customer (username, firstname, lastname, email, userrights, password) VALUES ('{customer.Username}', '{customer.Firstname}', '{customer.Lastname}', '{customer.Email}', 255, '{customer.Password}');";
            var cmd = new MySqlCommand(sql, con);

            if (cmd.ExecuteNonQuery() == 1)
            {
                return Ok(customer);
            }
            else
            {
                return BadRequest(new { ErrorCode = 400, ErrorMessage = "Customer not inserted" });
            }
        }

        // PUT api/<CustomerController>
        [Route("edit")]
        [HttpPut]
        public ActionResult<object> EditCustomer([FromBody] CustomerDto customer)
        {
            var con = new MySqlConnection(_connectionString);
            con.Open();

            string sql = $"UPDATE customer SET firstname = '{customer.Firstname}', lastname = '{customer.Lastname}', email = '{customer.Email}', password = '{customer.Password}' WHERE (username = '{customer.Username}');";
            var cmd = new MySqlCommand(sql, con);

            if (cmd.ExecuteNonQuery() == 1)
            {
                return Ok(customer);
            }
            else
            {
                return BadRequest(new { ErrorCode = 400, ErrorMessage = "Customer not updated" });
            }
        }

        // DELETE api/<CustomerController>/<username>
        [Route("delete")]
        [HttpDelete()]
        public ActionResult<object> DeleteCustomer(string username)
        {
            return BadRequest(new { ErrorCode = 400, ErrorMessage = "Customer cannot be deleted" });
        }
    }
}
