// DARK MODE TOGGLE
document.querySelector('.dark-mode-switch').onclick = () => {
    document.querySelector('body').classList.toggle('dark')
    document.querySelector('body').classList.toggle('light')
}

// CHECK LEAP YEAR
isLeapYear = (year) => {
    return (year % 4 === 0 && year % 100 !== 0 && year % 400 !==0) || (year % 100 === 0 && year % 400 ===0)
}

getFebDays = (year) => {
    return isLeapYear(year) ? 29 : 28
}

let calendar = document.querySelector('.calendar')

const month_names = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December']

let month_picker = document.querySelector('#month-picker')

month_picker.onclick = () => {
    month_list.classList.add('show')
}

update_current_date = (chosen_ybdate) => {
    var storedData = sessionStorage.getItem("customer_session_data");
    if (storedData) {
        logged_customer_data = JSON.parse(storedData);
        logged_customer_data.cursor_fromdate = chosen_ybdate;
        sessionStorage.setItem("customer_session_data", JSON.stringify(logged_customer_data));
    }
}

date_to_ybdate = (ainput) => {
    // return ainput.toISOString()
    //return ainput.toISOString().slice(0, 19).replace('T', ' ');
    return ainput.toDateString();
}

ybdate_to_date = (ainput) => {
    return new Date(ainput);
}

// GENERATE CALENDAR

generateCalendar = (imonth, year) => {
    let calendar_days = document.querySelector('.calendar-days')
    calendar_days.textContent = ''
    calendar_days.innerHTML = ''

    let calendar_header_year = document.querySelector('#year')

    let days_of_month = [31, getFebDays(year), 31, 30, 31, 30, 31, 31, 30, 31, 30, 31]

    let currDate = new Date()

    month_picker.innerHTML = month_names[imonth]
    calendar_header_year.innerHTML = year

	// javascript date takes the month by zb-index and not the real month 
    let first_day = new Date(year, imonth, 1)

    for (let i = 0; i <= days_of_month[imonth] + first_day.getDay() - 1; i++) {
        let day = document.createElement('div')
        if (i >= first_day.getDay()) {
            var loopDate = new Date(first_day);
            loopDate.setDate(loopDate.getDate() + i - first_day.getDay());
            day.classList.add('calendar-day-hover')
            day.id = date_to_ybdate(loopDate)
            day.addEventListener('dblclick', function (e) {                
                var xtarget = e.target
                var fromXDateParam = xtarget.id
                //alert(fromXDateParam)
                update_current_date(fromXDateParam)
                location.replace("daybookings.html")
            }, false);
            day.innerHTML = i - first_day.getDay() + 1
            day.innerHTML += '<span></span><span></span><span></span><span></span>'
            if (i - first_day.getDay() + 1 === currDate.getDate() && year === currDate.getFullYear() && imonth === currDate.getMonth()) {
                day.classList.add('curr-date')
            }
        }
        calendar_days.appendChild(day)
    }
}

let month_list = calendar.querySelector('.month-list')

month_names.forEach((e, index) => {
    let month = document.createElement('div')
    month.innerHTML = `<div>${e}</div>`
    month.onclick = () => {
        month_list.classList.remove('show')
        curr_month.value = index
        generateCalendar(curr_month.value, curr_year.value)
    }
    month_list.appendChild(month)
})

document.querySelector('#prev-year').onclick = () => {
    --curr_year.value
    generateCalendar(curr_month.value, curr_year.value)
}

document.querySelector('#next-year').onclick = () => {
    ++curr_year.value
    generateCalendar(curr_month.value, curr_year.value)
}

let currDate = new Date()

let curr_month = { value: currDate.getMonth() }
let curr_year = { value: currDate.getFullYear() }

generateCalendar(curr_month.value, curr_year.value)